{{ sdram-video-propfont-40MHz-test.spin }}
CON
  _clkmode = XTAL1 + PLL16X
  _xinfreq = 5_000_000

  QSIZE = 256

OBJ
  vid : "sdram-video-40MHz-le-propfont"

VAR

  long randstate
  long startline

PUB Main | col, i, j, k, m
  startline := 1
  vid.Start (@startline)

  waitcnt (CNT + clkfreq)

  randstate := CNT         ' dumb random generator for demo

  col := $FF               ' colour value
  j := 0
  k := 0

  vid.set_colours (col, col)
  repeat j from 10 to 469
    vid.draw_span (100, j, vid#WIDTH-200)  ' erase one page
    if (j & $1F) == 0
      col := (col+25) & $FF    ' change colour every so often
      vid.set_colours (col, 0)
  repeat j from 1 to 31
    vid.draw_span (104, j+40, j)
    vid.draw_span (180-j, j+40, j)
    vid.draw_span (304, j, j)
    vid.draw_span (380-j, j, j)
  waitcnt (CNT + 2*clkfreq)
  j := 0

  vid.drain_queues
 {
  repeat
    vid.set_colours (random (256), 0)
    repeat i from 1 to 20
      'vid.fill_rect (random (400), random (240), 401+random (400), 241+random (240))
      vid.do_circle (random (700)+50, random (vid#HEIGHT), random(70)+3 )
      'waitcnt (CNT + clkfreq/10)

  }
  waitcnt (CNT + 2*clkfreq)

  ' test pattern with random circles
  repeat
    'if col & 31 == 0
    vid.do_circle (random (500)+150, random (vid#HEIGHT), (col & 63)+1 { random(200)+1} )
    col := (col+1) &  $FF
    'startline ++
    vid.set_colours (col, 0)
    if col & 63 == 0
      waitcnt (CNT + clkfreq)
      'vid.set_colours (0, 0)
      'vid.fill_rect (0, 1, 799, 480)

      repeat k from 0 to 12
        vid.set_colours (col+k, 0)
        repeat i from 0 to 49
          vid.draw_glyph (i<<4, 1+(k<<5)+i, m & $FF)
          m ++
      waitcnt (CNT + clkfreq)
      repeat k from 0 to 100
        vid.set_colours (k<<26~>31, 0)
        repeat j from 0 to 200
          'waitcnt (CNT+clkfreq/50)
          vid.draw_glyph (random (784), random (480-32), random (256))

      waitcnt (CNT + clkfreq)
    if col & 0 == 0
      vid.fill_rect (random (400), random (200), 401+random (400), 201+random (200))
      vid.border_rect (random (400), random (200), 401+random (400), 201+random (200))
      vid.draw_rect (random (400), random (200), 401+random (400), 201+random (200))


PRI  sine (i)
  i |= 1
  if i < 0
    return -sine(-i)
  if i => $40000000
    return sine ($80000000-i)
  return word [$E000][(i>>19) & $7FF] ~> 8


PRI  random (n)
  randstate := randstate * 537 + $43853988       ' totally guessed linear congruential parameters(!)
  return (randstate >> 10) // n


{{
////////////////////////////////////////////////////////////////////////////////////////////
//                                TERMS OF USE: MIT License
////////////////////////////////////////////////////////////////////////////////////////////
// Permission is hereby granted, free of charge, to any person obtaining a copy of this
// software and associated documentation files (the "Software"), to deal in the Software
// without restriction, including without limitation the rights to use, copy, modify, merge,
// publish, distribute, sublicense, and/or sell copies of the Software, and to permit
// persons to whom the Software is furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all copies or
// substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
// INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
// PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
// FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
// DEALINGS IN THE SOFTWARE.
////////////////////////////////////////////////////////////////////////////////////////////
}}
